#ifdef __GNUG__
#pragma interface
#endif


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
void SharedCol<ELEM, KEYT, KEY>::commit(GenSharedMod* mod)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  Iterator<ObjectX> iter(*mod->_newElemList) ;
  for (; iter.more(); iter.next()) {
    ((DictX<ELEM, KEYT, KEY>*)mod->_savElemList)->insert(iter.get()) ;
  }

  Iterator<ObjectX> iter2(*mod->_delElemList) ;
  for (; iter2.more(); iter2.next()) {
    ((DictX<ELEM,KEYT,KEY>*)mod->_savElemList)->remove(*(Ref<ELEM>*)&iter2.get()) ;
  }
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
void SharedCol<ELEM, KEYT, KEY>::init() const
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  if (this->_delElemTab != NULL) return ;

  PageHdlMem* pd = yoo_getpage((void*)this) ;
  if (pd->getLock() < YOO_EXCL) {
    SYSCALLI(mprotect((caddr_t)pd->page(), PAGE_SIZE, PROT_READ|PROT_WRITE)) ;
  }

  SharedCol<ELEM, KEYT, KEY>* tmpthis = (SharedCol<ELEM, KEYT, KEY>*)this ;
    
  int size = tmpthis->_savElemList->count() ;
  tmpthis->_newElemList = new(YOO_TMP_CLU) DictX<ELEM, KEYT, KEY> ;
  tmpthis->_delElemTab = new TableOfBits(yoo_alignSup(size==0?1:size, 8));
  tmpthis->_delElemTab->one() ;

  GenSharedCol::listmod += new GenSharedMod(*this) ;
  
  if (pd->getLock() < YOO_EXCL) {
    SYSCALLI(mprotect((caddr_t)pd->page(), PAGE_SIZE, PROT_READ)) ;
  }
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
SharedCol<ELEM, KEYT, KEY>::SharedCol() 
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  if (YOO_LOAD_TIME == FALSE) {
    PageHdlMem* pd = yoo_getpage(this) ;
    Cluster* clu =  pd != NULL ? pd->page()->getCluster() : YOO_TMP_CLU ;
    this->_savElemList = new DictX<ELEM, KEYT, KEY> ;
  }
  this->_delElemTab = NULL ;
  this->_newElemList = NULL ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
SharedCol<ELEM, KEYT, KEY>::SharedCol(const SharedCol<ELEM, KEYT, KEY>& col)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->_delElemTab = NULL ;
  this->_newElemList = NULL ;
  (*this) = col ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
SharedCol<ELEM, KEYT, KEY>&
SharedCol<ELEM, KEYT, KEY>::operator=(const SharedCol<ELEM, KEYT, KEY>& col)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->clear() ;
  this->insert(col) ;
  return *this ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
Ref<ELEM> SharedCol<ELEM, KEYT, KEY>::get(const KEYT& k)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->init() ;

  Ref<ELEM> elem = this->_newElemList->getFirst(k) ;
  if (elem != NULL) return elem ;

  elem = this->_savElemList->getFirst(k) ;
  if (elem != NULL) {
    int pos = this->_savElemList->member(elem) ;
    if (_delElemTab->isset(pos,1)) {
      return elem ;
    }
  }

  return NULL ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
int SharedCol<ELEM, KEYT, KEY>::insert(const Ref<ELEM>& obj)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->init() ;

  if (this->member(obj) != -1) return 0 ;

  this->_newElemList->insert(obj) ;
  return 1 ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
int SharedCol<ELEM, KEYT, KEY>::remove(const Ref<ELEM>& obj)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->init() ;

  if (this->member(obj) == -1) return 0 ;

  if (this->_newElemList->member(obj) != -1) {
    this->_newElemList->remove(obj) ;
  } else {
    int pos = this->_savElemList->member(obj) ;
    this->_delElemTab->clear(pos, 1) ;
  }
  return 1 ;
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
int SharedCol<ELEM, KEYT, KEY>::member(const Ref<ELEM>& o) const
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  this->init() ;

  int i ;
  if ((_newElemList->member(o) != -1) ||
      (((i = _savElemList->member(o))!=-1) && (_delElemTab->isset(i,1)))) {
    return 0 ;
  } else {
    return -1 ;
  }
}


/*= EXTERNAL FUNCTION =======================================================*/
template <class ELEM, class KEYT, long KEY>
int SharedIterator<ELEM, KEYT, KEY>::go(const Ref<ELEM>& obj)
/*=
[DESCRIPTION :]
  (IN)  
  (OUT) 
[DIAGNOSTIC :]
[CALL :]
=*/
{
  int pos = this->_col._newElemList->member(obj) ;
  if (pos != -1) {
    this->_iterNew->go(pos) ;
    this->_iterCurr = this->_iterNew ;
    return 1 ;
  } else {
    pos = this->_col._savElemList->member(obj) ;
    if ((pos != -1) && (this->_col._delElemTab->isset(pos, 1))) {
      this->_iterSav->go(pos) ;
      this->_iterCurr = this->_iterSav ;
      this->_iterNew->go(this->_col._newElemList->count()) ;
      return 1 ;
    }
  }
  return 0 ;     
}
